itcl::class GrmParser {
    public variable scanner ""
    public variable verbose 0
    public variable verbout stderr
    private variable yystate 1
    private variable yysstack {1}
    private variable yydstack {}
    private variable yyreadnext 1
    private variable yylookahead
    private variable yyfinished 0
    private common yytrans
    private common yyredux
    private common yyrules

    array set yytrans {
        1,expression 2
        1,OPT_OPEN 6
        1,ALT_OPEN 16
        1,OPEN 21
        1,start 33
        1,STRING 24
        2,KLEENE 3
        2,PLUS 4
        2,expression 5
        2,OPT_OPEN 6
        2,TAG_OPEN 10
        2,ALT_OPEN 16
        2,OPEN 21
        2,STRING 24
        5,KLEENE 3
        5,PLUS 4
        5,expression 5
        5,OPT_OPEN 6
        5,TAG_OPEN 10
        5,ALT_OPEN 16
        5,OPEN 21
        5,STRING 24
        6,OPT_CLOSE 7
        6,expression 8
        6,expressionlist 31
        6,OPT_OPEN 6
        6,ALT_OPEN 16
        6,OPEN 21
        6,STRING 24
        6,expressionitem 27
        8,OPT_CLOSE 9
        8,KLEENE 3
        8,PLUS 4
        8,expression 5
        8,OPT_OPEN 6
        8,TAG_OPEN 10
        8,ALT_OPEN 16
        8,OPEN 21
        8,STRING 24
        10,stringitem 11
        10,stringlist 14
        10,STRING 12
        11,stringitem 11
        11,STRING 12
        11,stringlist 13
        14,TAG_CLOSE 15
        16,expressionlist 17
        16,expression 19
        16,OPT_OPEN 6
        16,ALT_CLOSE 26
        16,ALT_OPEN 16
        16,OPEN 21
        16,STRING 24
        16,expressionitem 27
        17,ALT_CLOSE 18
        19,KLEENE 3
        19,PLUS 4
        19,expression 5
        19,OPT_OPEN 6
        19,TAG_OPEN 10
        19,ALT_CLOSE 20
        19,ALT_OPEN 16
        19,OPEN 21
        19,STRING 24
        21,expression 22
        21,OPT_OPEN 6
        21,ALT_OPEN 16
        21,CLOSE 25
        21,OPEN 21
        21,STRING 24
        22,KLEENE 3
        22,PLUS 4
        22,expression 5
        22,OPT_OPEN 6
        22,TAG_OPEN 10
        22,ALT_OPEN 16
        22,CLOSE 23
        22,OPEN 21
        22,STRING 24
        27,OR 28
        28,expression 29
        28,expressionlist 30
        28,OPT_OPEN 6
        28,ALT_OPEN 16
        28,OPEN 21
        28,STRING 24
        28,expressionitem 27
        29,KLEENE 3
        29,PLUS 4
        29,expression 5
        29,OPT_OPEN 6
        29,TAG_OPEN 10
        29,ALT_OPEN 16
        29,OPEN 21
        29,STRING 24
        31,OPT_CLOSE 32
    }

    array set yyredux {
        2 2
        3 9
        4 8
        5 3
        7 13
        8 20
        9 15
        11 5
        12 6
        13 4
        15 7
        18 16
        19 20
        20 14
        23 10
        24 21
        25 11
        26 12
        27 19
        29 20
        30 18
        32 17
        33 0
    }

    array set yyrules {
        0 {__init__ {start}}
        2 {start {expression}}
        3 {expression {expression expression}}
        4 {stringlist {stringitem stringlist}}
        5 {stringlist {stringitem}}
        6 {stringitem {STRING}}
        7 {expression {expression TAG_OPEN stringlist TAG_CLOSE}}
        8 {expression {expression PLUS}}
        9 {expression {expression KLEENE}}
        10 {expression {OPEN expression CLOSE}}
        11 {expression {OPEN CLOSE}}
        12 {expression {ALT_OPEN ALT_CLOSE}}
        13 {expression {OPT_OPEN OPT_CLOSE}}
        14 {expression {ALT_OPEN expression ALT_CLOSE}}
        15 {expression {OPT_OPEN expression OPT_CLOSE}}
        16 {expression {ALT_OPEN expressionlist ALT_CLOSE}}
        17 {expression {OPT_OPEN expressionlist OPT_CLOSE}}
        18 {expressionlist {expressionitem OR expressionlist}}
        19 {expressionlist {expressionitem}}
        20 {expressionitem {expression}}
        21 {expression {STRING}}
    }

    constructor {args} {
        eval $this configure $args
    }
    
    public method reset {} {
        if {$verbose} {
            puts $verbout "GrmParser: reset, entering state 1"
        }
        set yystate 1
        set yysstack [list $yystate]
        set yydstack [list]
        set yyreadnext 1
        set yyfinished 0
    }
    
    protected method yyerror {yyerrmsg} {
        puts $verbout "GrmParser: $yyerrmsg"
    }
    
    private method yyshift {yytoken yydata} {
        set yynewstate $yytrans($yystate,$yytoken)
        lappend yysstack $yynewstate
        lappend yydstack $yydata
        
        if {$verbose} {
            puts $verbout "GrmParser: shifting token $yytoken, entering state $yynewstate"
        }
        
        set yystate $yynewstate
    }

    private method yyreduce {yyruleno} {
        set yylhs [lindex $yyrules($yyruleno) 0]
        set yyrhs [lindex $yyrules($yyruleno) 1]
        set yycount [llength $yyrhs]
        set yyssdepth [llength $yysstack]
        set yydsdepth [llength $yydstack]
        
        if {$verbose} {
            puts -nonewline $verbout "GrmParser: reducing rule # $yyruleno: $yylhs -->"
            foreach yytoken $yyrhs {
                puts -nonewline $verbout " "
                puts -nonewline $verbout $yytoken
            }
            puts $verbout ""
        }

        for {set yyi 0} {$yyi < $yycount} {incr yyi} {
            set yyvarname [expr {$yyi + 1}]
            set yyvarval  [lindex $yydstack [expr {$yydsdepth-$yycount+$yyi}]]
            set $yyvarname $yyvarval
        }
        
        set yyretcode [catch {
            switch -- $yyruleno {
                3 {
return "$1 $2"
                }
                4 {
return "$1 $2"
                }
                7 {
return "$1 <tag>SWI_meaning='$3'</tag>\n"
                }
                8 {
return "<item repeat=\"1-\">\n$1\n</item>\n"
                }
                9 {
return "<item repeat=\"0-\">\n$1\n</item>\n"
                }
                10 {
return "$2\n"
                }
                14 {
return "$2"
                }
                15 {
return "<item repeat=\"0-1\">\n$2\n</item>\n"
                }
                16 {
return "<one-of>\n$2\n</one-of>\n"
                }
                17 {
return "<item repeat=\"0-1\"><one-of> $2 </one-of></item>\n"
                }
                18 {
return "$1\n$3"
                }
                20 {
return "<item> $1 </item>"
                }
                21 {
return "$1"
                }
            }
        } yyretdata]
        
        if {$yyretcode == 0} {
            if {$yycount} {
                set yyretdata $1
            } else {
                set yyretdata ""
            }
        } elseif {$yyretcode == 1} {
            global errorInfo
            set yyerrmsg "script for rule # $yyruleno ($yylhs --> $yyrhs) failed: $yyretdata"
            yyerror $yyerrmsg
            append errorInfo "\n    while executing script for rule # $yyruleno ($yylhs --> $yyrhs)"
            error $yyerrmsg $errorInfo
        }
        
        set yysstack [lrange $yysstack 0 [expr {$yyssdepth-$yycount-1}]]
        set yydstack [lrange $yydstack 0 [expr {$yydsdepth-$yycount-1}]]
        set yystate [lindex $yysstack end]
        
        if {$verbose} {
            puts $verbout "GrmParser: entering state $yystate"
        }
        
        return $yyretdata
    }
    
    public method step {} {
        if {$yyfinished} {
           error "step beyond end of parse"
        }
        
        if {$yyreadnext} {
            set yylookahead [$scanner next]
            set yyreadnext 0
        }
        
        set yyterm [lindex $yylookahead 0]
        set yydata [lindex $yylookahead 1]
        
        if {[info exists yytrans($yystate,$yyterm)]} {
            yyshift $yyterm $yydata
            set yyreadnext 1
            return [list $yyterm $yydata]
        } elseif {[info exists yyredux($yystate)] || \
                [info exists yyredux($yystate,$yyterm)]} {
            if {[info exists yyredux($yystate)]} {
                set yyruleno $yyredux($yystate)
            } else {
                set yyruleno $yyredux($yystate,$yyterm)
            }
            
            set yyreduxlhs [lindex $yyrules($yyruleno) 0]
            set yyreduxdata [yyreduce $yyruleno]
            
            if {$yyreduxlhs == "__init__"} {
                set yyfinished 1
            } else {
                yyshift $yyreduxlhs $yyreduxdata
            }
            return [list $yyreduxlhs $yyreduxdata]
        } else {
            global errorInfo
            set yyerrmsg "parse error reading \"$yyterm\" in state $yystate"
            set errorInfo $yyerrmsg
            append errorInfo "\n    expecting one of:"
            foreach yylaname [array names yytrans $yystate,*] {
                append errorInfo "\n        " [lindex [split $yylaname ,] 1]
            }
            yyerror $yyerrmsg
            error $yyerrmsg $errorInfo
        }
        
        error "oops: unreachable code"
    }
    
    public method parse {} {
        if {$scanner == ""} {
            global errorInfo
            set yyerrmsg "cannot start parsing without a scanner"
            set errorInfo $yyerrmsg
            yyerror $yyerrmsg
            error $yyerrmsg $errorInfo
        }
        
        while {!$yyfinished} {
            set yydata [step]
        }
        
        if {[lindex $yylookahead 0] != ""} {
            global errorInfo
            set yyerrmsg "parser finished, but not at EOF (lookahead: [lindex $yylookahead 0])"
            set errorInfo $yyerrmsg
            yyerror $yyerrmsg
            error $yyerrmsg
        }
        
        return [lindex $yydata 1]
    }
}


