array set menu {
  w,file,open					{$widget(m_file) 0}
  w,file,new					{$widget(m_file) 1}
  w,file,close				{$widget(m_file) 2}
  w,file,save					{$widget(m_file) 3}
  w,file,saveas				{$widget(m_file) 4}
	# -------------------------------------------------------------
  w,file,merge				{$widget(m_file) 6}
  w,file,export				{$widget(m_file) 7}
  w,file,export,phr 	{$widget(m_file_export) 0}
  w,file,export,rtf		{$widget(m_file_export) 1}
  w,file,export,xml		{$widget(m_file_export) 2}
  w,file,export,html	{$widget(m_file_export) 3}
  w,file,export,vdx		{$widget(m_file_export) 4}
  w,file,export,stw		{$widget(m_file_export) 5}
  w,file,export,ps		{$widget(m_file_export) 6}
  w,file,export,gif		{$widget(m_file_export) 7}
  w,file,export,gml		{$widget(m_file_export) 8}
  w,file,export,scall	{$widget(m_file_export) 9}
  w,file,export,audio	{$widget(m_file_export) 10}
	# -------------------------------------------------------------
  w,file,export,tcl		{$widget(m_file_export) 12}
  w,file,export,xhmi	{$widget(m_file_export) 13}
  w,file,export,vxml	{$widget(m_file_export) 14}
  w,file,export,osdm	{$widget(m_file_export) 15}
  w,file,import				{$widget(m_file) 8}
  w,file,import,txt		{$widget(m_file_import) 0}
  w,file,import,scall	{$widget(m_file_import) 1}
	# -------------------------------------------------------------
  w,file,exit					{$widget(m_file) 10}

  w,edit,prompt			{$widget(m_edit) 0}
  w,edit,question		{$widget(m_edit) 1}
  w,edit,concept		{$widget(m_edit) 2}
  w,edit,scall			{$widget(m_edit) 3}
  w,edit,rename			{$widget(m_edit) 4}
	# -------------------------------------------------------------
	w,edit,undo				{$widget(m_edit) 6}
	w,edit,redo				{$widget(m_edit) 7}
	w,edit,undo_all		{$widget(m_edit) 8}
	w,edit,redo_all		{$widget(m_edit) 9}
	# -------------------------------------------------------------
  w,edit,group			{$widget(m_edit) 11}
  w,edit,ungroup		{$widget(m_edit) 12}
  w,edit,compact		{$widget(m_edit) 13}
  w,edit,sync				{$widget(m_edit) 14}
  w,edit,remaudio		{$widget(m_edit) 15}
  w,edit,newaudio		{$widget(m_edit) 16}
  w,edit,autocalls	{$widget(m_edit) 17}
	# -------------------------------------------------------------
  w,edit,opt				{$widget(m_edit) 19}

  w,view,refresh	{$widget(m_view) 0}
  w,view,layout		{$widget(m_view) 1}
  w,view,showconn	{$widget(m_view) 2}

  w,run,session		{$widget(m_run) 0}
  w,run,run				{$widget(m_run) 1}
	# -------------------------------------------------------------
  w,run,analyze		{$widget(m_run) 3}
  w,run,sc_analyze {$widget(m_run) 4}
  w,edit,updlog		{$widget(m_run) 5}
	# -------------------------------------------------------------
  w,run,tts				{$widget(m_run) 7}

  w,help,docs			{$widget(m_help) 0}
	# -------------------------------------------------------------
  w,help,about		{$widget(m_help) 2}
  w,help,log			{$widget(m_help) 3}

	c,edit,undo {
		#move::debug
		move::undo
		#move::debug
		updateList
	}
	
	c,edit,redo {
		#move::debug
		move::redo
		#move::debug
		updateList
	}

	c,edit,undo_all {
		move::undo all
		updateList
	}
	
	c,edit,redo_all {
		move::redo all
		updateList
	}

  c,init {
  	global widget menu woz label plugin var options

		# start logging system
		logStart
		log [res::Str log_start [res::Str about]]

		# menu language
		foreach n [array names menu w,*] {
		  set ntmp [split $n ","]
		  eval [lindex $menu($n) 0] entryconfigure [lindex $menu($n) 1] \
		    -label \"[res::Str m_[join [lrange $ntmp 1 end] "_"]]\"
		}
		$widget(mm_file) configure -text [res::Str m_main_file]
		$widget(mm_edit) configure -text [res::Str m_main_edit]
		$widget(mm_view) configure -text [res::Str m_main_view]
		$widget(mm_run)  configure -text [res::Str m_main_run]
		$widget(mm_help) configure -text [res::Str m_main_help]

		# toolbar
		set widget(update,undo) ""	
		set widget(update,redo) ""

		foreach n [array names widget tool*] {
			# ini entry exists --> configure widget, else remove it
			if {[ini::Exists $n.Icon]} {
				image create photo $n -file $woz(RES)/icons/[ini::Str $n.Icon].gif
				$widget($n) configure \
											-image $n \
											-command "menuCommand [ini::Str $n.Cmd]"
				
				# bubble help
				balloon $widget($n) [res::Str b_[join [split [ini::Str $n.Cmd] ","] "_"]]
				
				# store edit,undo and edit,redo for later dynamic bubble updates
				if {[ini::Str $n.Cmd]=="edit,undo"} {set widget(update,undo) [list $n [res::Str b_[join [split [ini::Str $n.Cmd] ","] "_"]]]}
				if {[ini::Str $n.Cmd]=="edit,redo"} {set widget(update,redo) [list $n [res::Str b_[join [split [ini::Str $n.Cmd] ","] "_"]]]}
				
				# store the button widget to the command for later use
				set menu(b,[ini::Str $n.Cmd]) $widget($n)
			} else {
				destroy $widget($n)
			}
		}
		
		# form labels
		foreach n1 [concat $plugin(pix,vars) $plugin(pix,text) \
									$plugin(qix,vars) $plugin(qix,text) \
									$plugin(cix,vars) $plugin(cix,text) c_check \
									$plugin(six,vars) $plugin(six,text) \
									p_header q_header c_header s_header c_usedby \
									o_header o_condition \
									p_predecessors q_predecessors \
									run_namesort run_indexsort run_textsort run_condsort run_log] {
			set label(opt,$n1) [res::Str "b_label_$n1"]
		}
		
		# option labels
		foreach n1 {exc} {
			foreach n2 {nr nu re tl header} {
				set tmp [join [split "opt,$n1,$n2" ","] "_"]
				set label(opt,$n1,$n2) [res::Str $tmp]
			}
		}
		set label(set_name) [res::Str set_name]

		# options defaults
		foreach tmp {sc_create_missing_obj sc_create_new_obj sc_create_new_connections sc_create_new_concepts} {
			set options($tmp) 1
		}
		set options(sc_update_wordings) do_nothing

		# enable and possibly activate the TTS switch		
		if {$woz(sapi)!={}} {
		  menuAble run,tts 1
			if {[ini::Str common.tts_on]==1} {
				set var(tts) 1
			}
		} else {
		  menuAble run,tts 0
		}
  }

  c,file,open	{
		global plugin statusMsg widget
	
		set ft [list \
		  [list [ini::Str files.wozType] [ini::Str files.wozExt]] \
		  [list [ini::Str files.allType] [ini::Str files.allExt]] \
		]
		set fn [tk_getOpenFile \
		  -filetypes $ft \
		  -defaultextension  [ini::Str files.wozExt] \
		  -initialdir [ini::Str files.wozDir]]
	
		if {$fn!={}} {
		  if {![prjOpen $fn]} {
		    tk_messageBox -message $statusMsg -type ok
		  } else {
		    log [res::Str log_open $fn]
		    wm title $widget(main) [res::Str win_main $plugin(name) [file tail $fn]]
	      updateList
		    prjFlags "-" "-" 0
		  }
		}
  }

  c,autostart	{
		global plugin statusMsg widget argv
	
		set fn [lindex $argv 0]
		if {$fn==""} {set fn [ini::Str common.initialProject]}

		if {$fn!={}} {
		  if {![prjOpen $fn]} {
		    tk_messageBox -message $statusMsg -type ok
		  } else {
		    log [res::Str log_open $fn]
		    wm title $widget(main) [res::Str win_main $plugin(name) [file tail $fn]]
				updateList
		    prjFlags "-" "-" 0
		  }
		}
  }

  c,file,new	{
		global plugin statusMsg widget
	
		if {![prjNew]} {
		  tk_messageBox -message $statusMsg -type ok
		} else {
		  log [res::Str log_new]
		  wm title $widget(main) [res::Str win_main $plugin(name) ""]
		  prjFlags "-" "-" 0
			updateList
		}
  }

  c,file,close	{
		global plugin statusMsg widget
	
		if {![prjClose]} {
		  tk_messageBox -message $statusMsg -type ok
		} else {
		  log [res::Str log_close]
		  wm title $widget(main) [res::Str win_main [res::Str no_project] ""]
		  prjFlags "-" "-" 0
			updateList
		}
  }

  c,file,save	{
		global plugin statusMsg
	
		if {![prjSave $plugin(prj,loaded)]} {
		  tk_messageBox -message $statusMsg -type ok
		} else {
		  log [res::Str log_save $plugin(prj,loaded)]
		}
  }

  c,file,saveas	{
		global plugin statusMsg widget
	
		if {![prjSave ""]} {
		  tk_messageBox -message $statusMsg -type ok
		} else {
		  log [res::Str log_save $plugin(prj,loaded)]
		  wm title $widget(main) [res::Str win_main $plugin(name) [file tail $plugin(prj,loaded)]]
		}
  }

  c,file,merge	{
		global plugin statusMsg widget
 
		set ft [list \
			[list [ini::Str files.wozType] [ini::Str files.wozExt]] \
			[list [ini::Str files.allType] [ini::Str files.allExt]] \
		]
    set fn [tk_getOpenFile \
      -filetypes $ft \
      -defaultextension  [ini::Str files.wozExt] \
      -initialdir [ini::Str files.wozDir]]

    if {$fn!={}} {
      if {![prjMerge $fn]} {
        tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_merge $fn]
        updateList
      }
    }
  }

  c,file,export,phr	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.phrType] [ini::Str files.phrExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.phrExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension  [ini::Str files.phrExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {![wozExportPhraseList $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "phrase list" $fn]
				if {[ini::Str Files.showExport]=="1"} {
					showFile $fn
				}
      }
    }
  }

  c,file,export,stw	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.stwType] [ini::Str files.stwExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.stwExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.stwExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {![wozExportStudioWorks $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "StudioWorks file" $fn]
				if {[ini::Str Files.showExport]=="1"} {
					showFile $fn
				}
      }
    }
  }

  c,file,export,ps	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.psType] [ini::Str files.psExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.psExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.psExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {[catch {wozExportPostscript $fn} statusMsg]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "Postscript file" $fn]
      }
    }
  }

  c,file,export,gif	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.gifType] [ini::Str files.gifExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.gifExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.gifExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {[catch {wozExportGIF $fn} statusMsg]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "GIF image" $fn]
      }
    }
  }

  c,file,export,xml	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.xmlType] [ini::Str files.xmlExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.xmlExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.xmlExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {![wozExportXML $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "XML file" $fn]
				if {[ini::Str Files.showExport]=="1"} {
					showFile $fn
				}
      }
    }
  }

  c,file,export,gml	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.gmlType] [ini::Str files.gmlExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.gmlExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.gmlExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {![wozExportGML $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "GML file" $fn]
				if {[tk_messageBox -message "Open application for $fn?" -type yesno]=="yes"} {
					startFile $fn
				} else {
					if {[ini::Str Files.showExport]=="1"} {
						showFile $fn
					}
				}
      }
    }
  }

  c,file,export,vxml	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.vxmlType] [ini::Str files.vxmlExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.vxmlExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.vxmlExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
	    if {[wozAnalyze 1]} {
	      if {![wozExportVoiceXML $fn]} {
					tk_messageBox -message $statusMsg -type ok
	      } else {
	        log [res::Str log_export "VoiceXML file" $fn]
					if {[ini::Str Files.showExport]=="1"} {
						showFile $fn
					}
	      }
			}
    }
  }

  c,file,export,html	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.htmlType] [ini::Str files.htmlExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.htmlExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.htmlExt] \
      -initialdir [ini::Str files.expDir]]
    if {$fn!={}} {
      if {![wozExportHTML $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "HTML file" $fn]
      }
    }
  }

  c,file,export,xhmi	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.xhmiType] [ini::Str files.xhmiExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.xhmiExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.xhmiExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
	    if {[wozAnalyze 1]} {
	      if {![wozExportXHMI $fn]} {
					tk_messageBox -message $statusMsg -type ok
	      } else {
	        log [res::Str log_export "xHMI file" $fn]
					if {[ini::Str Files.showExport]=="1"} {
						showFile $fn
					}
	      }
			}
    }
  }

  c,file,export,vdx	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.vdxType] [ini::Str files.vdxExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.vdxExt]"
    set fn [tk_getSaveFile \
      -filetypes $ft \
      -initialfile $fn \
      -defaultextension [ini::Str files.vdxExt] \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {![wozExportVDX $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "VDX file" $fn]
      }
    }
  }

  c,file,export,rtf	{
    global statusMsg widget plugin

    # analyze makes sure that all titles exist
    if {[wozAnalyze 1]} {
      set dir "[ini::Str files.expDir]"
      set dir [tk_chooseDirectory -initialdir $dir]

      if {$dir!={}} {
        if {![wozExportRTF $dir]} {
				  tk_messageBox -message $statusMsg -type ok
        } else {
          log [res::Str log_export "RTF Files" $dir]
        }
      }
    }
  }

  c,file,export,osdm	{
    global statusMsg widget plugin

    # analyze makes sure that all titles exist
    if {[wozAnalyze 1]} {
      set dir "[ini::Str files.expDir]"
      set dir [tk_chooseDirectory -initialdir $dir]

      if {$dir!={}} {
        if {![wozExportOSDM $dir]} {
				  tk_messageBox -message $statusMsg -type ok
        } else {
          log [res::Str log_export "OSDM Properties" $dir]
        }
      }
    }
  }

  c,file,export,nuance_rtf	{
    global statusMsg widget plugin

    # analyze makes sure that all titles exist
    if {[wozAnalyze 1]} {
      set dir "[ini::Str files.expDir]"
      set dir [tk_chooseDirectory -initialdir $dir]

      if {$dir!={}} {
        if {![wozExportRTF_Nuance $dir]} {
				  tk_messageBox -message $statusMsg -type ok
        } else {
          log [res::Str log_export "RTF Files (Nuance)" $dir]
        }
      }
    }
  }

  c,file,export,scall	{
    global statusMsg widget plugin

    # analyze makes sure that all titles exist
    if {[wozAnalyze 1]} {
      set dir "[ini::Str files.expDir]"
      set dir [tk_chooseDirectory -initialdir $dir]

      if {$dir!={}} {
        if {![wozExportSampleCalls $dir]} {
				  tk_messageBox -message $statusMsg -type ok
        } else {
          log [res::Str log_export "Sample calls" $dir]
        }
      }
    }
  }

  c,file,export,audio	{
    global statusMsg widget plugin

    set dir "[ini::Str files.expDir]"
    set dir [tk_chooseDirectory -initialdir $dir]

    if {$dir!={}} {
      if {![wozExportAudio $dir]} {
			  tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_export "Sample calls audio" $dir]
      }
    }
  }

  c,file,import,txt	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.scType] [ini::Str files.scExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn [tk_getOpenFile \
      -filetypes $ft \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
			if {![wozImportText $fn]} {
				tk_messageBox -message $statusMsg -type ok
			} else {
			  log [res::Str log_import "design from text file" $fn]
				updateList
      }
    }
  }

  c,file,import,gml	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.gmlType] [ini::Str files.gmlExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn [tk_getOpenFile \
      -filetypes $ft \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
			if {![wozImportGML $fn]} {
				tk_messageBox -message $statusMsg -type ok
			} else {
			  log [res::Str log_import "coordinates from GML file" $fn]
				updateList
      }
    }
  }

  c,file,import,scall	{
    global statusMsg widget plugin

    set ft [list \
    	[list [ini::Str files.scType] [ini::Str files.scExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn [tk_getOpenFile \
      -filetypes $ft \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
			if {![wozImportSampleCall $fn]} {
				tk_messageBox -message $statusMsg -type ok
			} else {
			  log [res::Str log_import "sample call from text file" $fn]
				updateList
      }
    }
  }

  c,file,exit {
		global plugin widget
		if {![info exists plugin(EXIT)]} {
		  if {[prjClose]} {
		    log [res::Str log_stop]
		    logStop
		    set plugin(EXIT) 1
		    exit
		  }
		}
  }

  c,edit,prompt	{
    global plugin widget var

    # calculate the ID of the new entry
    set id [nextId "P"]

    if {$id==""} {
      log [res::Str log_nomorep]
    } else {
			set commands [createPromptCommands $id]
    	move::add [lindex $commands 0] [lindex $commands 1] [res::Str undo_new_prompt $id]
			editProperties $widget(canvas) $id
			set var(newid) $id
      set plugin(prj,changed) 1
      updateList
    }
  }

  c,edit,question	{
    global plugin widget var

    # calculate the ID of the new entry
    set id [nextId "Q"]

    if {$id==""} {
      log [res::Str log_nomoreq]
    } else {
			set commands [createQuestionCommands $id]
    	move::add [lindex $commands 0] [lindex $commands 1] [res::Str undo_new_question $id]
			editProperties $widget(canvas) $id
			set var(newid) $id
      set plugin(prj,changed) 1
      updateList
    }
  }

  c,edit,concept	{
    global plugin widget var

    # calculate the ID of the new entry
    set id [nextId "C"]

    if {$id==""} {
      log [res::Str log_nomorec]
    } else {
			set commands [createConceptCommands $id]
    	move::add [lindex $commands 0] [lindex $commands 1] [res::Str undo_new_concept $id]
			editProperties $widget(canvas) $id
			set var(newid) $id
      set plugin(prj,changed) 1
      updateList
    }
  }

  c,edit,scall	{
    global plugin widget var

    # calculate the ID of the new entry
    set id [nextId "S"]

    if {$id==""} {
      log [res::Str log_nomoreq]
    } else {
    	set redo_cmd ""

      # preset empty values
      foreach n [concat $plugin(six,vars) $plugin(six,text)] {
      	append redo_cmd "set plugin($id,$n) [list {}];"
      }
      append redo_cmd "set plugin($id,id) $id;"
      append redo_cmd "set plugin($id,s_id) $id;"
      append redo_cmd "set plugin($id,s_name) \"Call $id\";"

    	move::add $redo_cmd "array unset plugin $id,*" \
    		[res::Str undo_new_scall $id]

			editPropertiesFromList $id
			set var(newid) $id
      set plugin(prj,changed) 1
      updateList
    }
  }

  c,edit,group	{
    global plugin curobj

    # select the entries to group
    set group [dia::choosePQmulti]

		set undo_cmd ""
		set redo_cmd ""

    # apply them all to each other
    if {$group!={}} {
      foreach e $group {
        if {[isPrompt $e]} {
					append undo_cmd "set plugin($e,p_follows) [list $plugin($e,p_follows)];"
          append redo_cmd "set plugin($e,p_follows) [list $group];"
        } else {
					append undo_cmd "set plugin($e,q_follows) [list $plugin($e,q_follows)];"
          append redo_cmd "set plugin($e,q_follows) [list $group];"
        }
      }

			move::add $redo_cmd $undo_cmd [res::Str undo_group]
	    set plugin(prj,changed) 1
		  updateList
    }
  }

  c,edit,ungroup	{
    global plugin curobj

    # select the entries to ungroup
    set group [dia::choosePQmulti]

		set undo_cmd ""
		set redo_cmd ""

    # delete their connections
    if {$group!={}} {
      foreach e $group {
        if {[isPrompt $e]} {
					append undo_cmd "set plugin($e,p_follows) [list $plugin($e,p_follows)];"
          append redo_cmd "set plugin($e,p_follows) {};"
        } else {
					append undo_cmd "set plugin($e,q_follows) [list $plugin($e,q_follows)];"
          append redo_cmd "set plugin($e,q_follows) {};"
        }
      }

			move::add $redo_cmd $undo_cmd [res::Str undo_ungroup]
	    set plugin(prj,changed) 1
		  updateList
    }
  }

  c,edit,compact	{
    compactNamespace
    updateList
	}

  c,edit,sync	{
  	global var widget
  	
		set var(sync) [allEntries S]
		set var(undoDomain) ""
		::vTcl:Toplevel:WidgetProc $widget(sync_sc) startmodal
	}

  c,edit,remaudio	{
		removeAllStandardAudioFilenames
	}

  c,edit,newaudio	{
		correctAllStandardAudioFilenames
	}

  c,edit,autocalls	{
  	global widget
		::vTcl:Toplevel:WidgetProc $widget(generate_sc) startmodal
	}

  c,edit,updlog {
    global statusMsg widget plugin

    set ft [list \
    	[list "Log Files" ".log"] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
    ]
    set fn [tk_getOpenFile \
      -filetypes $ft \
      -initialdir [ini::Str files.expDir]]

    if {$fn!={}} {
      if {![updateDiaLog $fn]} {
				tk_messageBox -message $statusMsg -type ok
      } else {
        log [res::Str log_update "Dialog log file" $fn]
      }
    }
  }

  c,view,refresh	{
    updateList
  }

	c,view,layout {
		layoutInit
		layout getChildren
		updateList
	}
	
  c,edit,opt	{
    global options widget
		::vTcl:Toplevel:WidgetProc $widget(winopt) startmodal
  }

  c,run,analyze	{
    wozAnalyze
  }

  c,run,sc_analyze	{
    scAnalyze
  }

  c,run,session	{
    global statusMsg widget woz plugin

    if {[wozAnalyze 1]} {
      set ft [list \
    	[list [ini::Str files.tclType] [ini::Str files.tclExt]] \
    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
      ]
      set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.tclExt]"
      set fn [tk_getSaveFile \
        -filetypes $ft \
        -defaultextension  [ini::Str files.tclExt] \
        -initialfile $fn \
        -initialdir [ini::Str files.expDir]]

      if {$fn!={}} {
        if {![wozExportTclTk $fn]} {
				  tk_messageBox -message $statusMsg -type ok
        } else {
          log [res::Str log_export "WOZ session" $fn]
        }
      }
    }
  }

  c,run,run	{
    global statusMsg widget woz plugin tcl_platform

    if {[wozAnalyze 1]} {
      set ft [list \
	    	[list [ini::Str files.tclType] [ini::Str files.tclExt]] \
	    	[list [ini::Str files.allType] [ini::Str files.allExt]] \
      ]
      set fn "[file rootname [file tail $plugin(prj,loaded)]][ini::Str files.tclExt]"
      set fn [tk_getSaveFile \
        -filetypes $ft \
        -defaultextension  [ini::Str files.tclExt] \
        -initialfile $fn \
        -initialdir [ini::Str files.expDir]]

      if {$fn!={}} {
        if {![wozExportTclTk $fn]} {
				  tk_messageBox -message $statusMsg -type ok
        } else {
          log [res::Str log_export "WOZ session" $fn]
          # execute the script
				  if {[catch {exec [ini::Str $tcl_platform(platform).wish] $fn &}]} {
				    tk_messageBox -message [res::Str cfgwish [ini::Str $tcl_platform(platform).wish]] -type ok
				  }
        }
      }
    }
  }

  c,help,docs {startFile doc/index.html}

  c,help,about {splash}

  c,help,log {showLog}
}

proc menuAble {m enabled} {
  global menu widget

  # menu
  if {[info exists menu(w,$m)]} {
    if {$enabled} {
      eval [lindex $menu(w,$m) 0] entryconfigure [lindex $menu(w,$m) 1] -state normal
    } else {
      eval [lindex $menu(w,$m) 0] entryconfigure [lindex $menu(w,$m) 1] -state disabled
    }
  }

  # toolbar
  if {[info exists menu(b,$m)]} {
    if {$enabled} {
      $menu(b,$m) configure -state normal
    } else {
      $menu(b,$m) configure -state disabled
    }
  }
}

proc menuSetState {} {
  global plugin menu woz

  # turn everything off (on menu level 1)
  foreach n [concat [array names menu w,*] [array names menu c,*]] {
		# tts is controlled by the tcl/tk configuration
		if {[string range $n 2 end]!="run,tts"} {
	  	menuAble [string range $n 2 end] 0
		}
  }

  # turn some always on
  menuAble file,new 1
  menuAble file,open 1
  menuAble file,exit 1
  menuAble help,about 1
  menuAble help,docs 1
  menuAble help,log 1

  # turn off most on menu level 2
  menuAble file,export,phr 0
  menuAble file,export,tcl 0
  menuAble file,export,rtf 0
  menuAble file,export,nuance_rtf 0
  menuAble file,export,xml 0
  menuAble file,export,html 0
  menuAble file,export,xhmi 0
  menuAble file,export,vxml 0
  menuAble file,export,osdm 0
  menuAble file,export,vdx 0
  menuAble file,export,stw 0
  menuAble file,export,ps 0
  menuAble file,export,gif 0
  menuAble file,export,gml 0
  menuAble file,export,scall 0
  menuAble file,export,audio 0
  menuAble file,import,txt 0
  menuAble file,import,scall 0

  # turn some sometimes on
  if {$plugin(prj,loaded)!=""} {
		menuAble file,import 1
		menuAble file,import,txt 1
		menuAble file,import,scall 1
		menuAble file,close 1
		menuAble file,save 1
		menuAble file,saveas 1
		menuAble file,merge 0
		
		menuAble edit,prompt 1
		menuAble edit,question 1
		menuAble edit,concept 1
		menuAble edit,scall 1
		menuAble edit,updlog 1
		menuAble edit,opt 1

		menuAble view,refresh 1
		menuAble view,showconn 1
	
		# some are possible if there's at least one entry
		if {[array get plugin *,id]!={}} {
			menuAble view,layout 1
			menuAble run,analyze 1
			menuAble run,sc_analyze 1
			menuAble edit,group 1
			menuAble edit,ungroup 1
			menuAble run,session 1
			menuAble run,run 1
			menuAble edit,compact 1
			menuAble edit,sync 1
			menuAble edit,rename 0
			menuAble file,export 1
			menuAble edit,remaudio 1
			menuAble edit,newaudio 1
			menuAble edit,autocalls 1
	
			menuAble file,export,phr 1
			menuAble file,export,tcl 1
			menuAble file,export,rtf 1
			menuAble file,export,nuance_rtf 1
			menuAble file,export,xml 1
			menuAble file,export,html 1
			menuAble file,export,xhmi 0
			menuAble file,export,vxml 1
			menuAble file,export,osdm 1
			menuAble file,export,vdx 0
			menuAble file,export,stw 1
			menuAble file,export,ps 1
			menuAble file,export,gif 1
			menuAble file,export,gml 1
			menuAble file,export,scall 1
			menuAble file,export,audio 1
		}
		
		# undo/redo are possible if there's at least one command
		if {[move::isUndo]} {
			menuAble edit,undo 1
			menuAble edit,undo_all 1
		}
		if {[move::isRedo]} {
			menuAble edit,redo 1
			menuAble edit,redo_all 1
		}
  }
}

proc menuCommand {m} {
  global menu

  if {[info exists menu(c,$m)]} {
    eval $menu(c,$m)
  } else {
		bell
  }
  menuSetState
}

proc updateList {{graphics 1} {text 1}} {
  global widget plugin

	# ================ CANVAS ==================
	if {$graphics} {
		# delete all items from the canvas
		resetCanvas
	
		# recreate all objects
	  set minx -10000
	  set miny -10000
	  
	  foreach n [lsort [allEntries P]] {
			set tmp [util::oneLine $plugin($n,p_prompt) [ini::Str Graphics.canvasDisplayLength]]
			set color [ini::Str common.colorP]
			if {$plugin($n,p_start)==1} {set color [ini::Str common.colorP1]}
			createBox $widget(canvas) \
				$plugin($n,x) $plugin($n,y) \
				$color \
				$n \
				"Prompt $n" \
				"[string range $plugin($n,p_title) 0 [ini::Str Graphics.canvasDisplayLength]]\n$tmp" \
				[isEndState $n] \
				[expr \$plugin($n,p_vxml)==1]
			if {$plugin($n,x)>$minx} {set minx $plugin($n,x)}
			if {$plugin($n,y)>$miny} {set miny $plugin($n,y)}
	  }
	  foreach n [lsort [allEntries Q]] {
			set tmp [util::oneLine $plugin($n,q_init) [ini::Str Graphics.canvasDisplayLength]]
				createBox $widget(canvas) \
				$plugin($n,x) $plugin($n,y) \
				[ini::Str common.colorQ] \
				$n \
				"Question $n" \
				"[string range $plugin($n,q_title) 0 [ini::Str Graphics.canvasDisplayLength]]\n$tmp" \
				[isEndState $n] \
				[expr \$plugin($n,q_vxml)==1]
			if {$plugin($n,x)>$minx} {set minx $plugin($n,x)}
			if {$plugin($n,y)>$miny} {set miny $plugin($n,y)}
	  }
	
		if {$minx==-10000} {set minx 0}
		if {$miny==-10000} {set miny 0}

		# enlarge area
		set minx [expr $minx+400]
		set miny [expr $miny+400]
	
		# define scrollregion
		$widget(canvas) configure -scrollregion [list 0 0 $minx $miny]
	
		# recreate all connections
	  foreach n [lsort [allEntries P]] {
			foreach tmp $plugin($n,p_follows) {
				connectRectangles $widget(canvas) $n $tmp last [lineColor $n $tmp]
			}
	  }
	  foreach n [lsort [allEntries Q]] {
			foreach tmp $plugin($n,q_follows) {
				connectRectangles $widget(canvas) $n $tmp last [lineColor $n $tmp]
			}
	  }
	}
  
 	# ================ LISTBOX ==================
	if {$text} {
		$widget(textlist) delete 0 end
	
		set ix 0
	  foreach n [lsort [allEntries P]] {
			$widget(textlist) insert end "$n | $plugin($n,p_title) | $plugin($n,p_prompt)"
			if {$plugin($n,p_start)==1} {
				$widget(textlist) itemconfigure $ix -background [ini::Str common.colorP1]
			} else {
				$widget(textlist) itemconfigure $ix -background [ini::Str common.colorP]
			}
			incr ix
		}
	  foreach n [lsort [allEntries Q]] {
			$widget(textlist) insert end "$n | $plugin($n,q_title) | $plugin($n,q_init)"
			$widget(textlist) itemconfigure $ix -background [ini::Str common.colorQ]
			incr ix
		}
	  foreach n [lsort [allEntries C]] {
			$widget(textlist) insert end "$n | $plugin($n,c_title) | $plugin($n,c_name)"
			$widget(textlist) itemconfigure $ix -background [ini::Str common.colorC]
			incr ix
		}
	  foreach n [lsort [allEntries S]] {
			set warnings [llength [sampleCallWarnings $n]]
			if {$warnings==0} {
				$widget(textlist) insert end "$n | \[[llength $plugin($n,s_call)]\] $plugin($n,s_name) | $plugin($n,s_memo)"
				$widget(textlist) itemconfigure $ix -background [ini::Str common.colorS]
			} else {
				$widget(textlist) insert end "$n | \[[llength $plugin($n,s_call)]\] $plugin($n,s_name) ($warnings warnings) | $plugin($n,s_memo)"
				$widget(textlist) itemconfigure $ix -background [ini::Str common.colorS] -foreground [ini::Str Common.colorSwarn]
			}
			incr ix
		}
	  foreach n [lsort [allConnections]] {
	  	set nn "O,[lindex $n 0],[lindex $n 1]"
			if {[util::value plugin($nn)]!=""} {
				$widget(textlist) insert end "[lindex $n 0] > [lindex $n 1] | $plugin($nn)"
				$widget(textlist) itemconfigure $ix -foreground [ini::Str Graphics.connColorAttributed]
			} else {
				$widget(textlist) insert end "[lindex $n 0] > [lindex $n 1]"
				$widget(textlist) itemconfigure $ix -foreground [ini::Str Graphics.connColorNoAttribute]
			}
			$widget(textlist) itemconfigure $ix -background [ini::Str common.colorO]
			incr ix
		}
	}
}

proc updateUndoRedo {domain} {
	global widget

	if {$domain=="global"} {
		# update the balloon help with the last stored comments
		if {$widget(update,undo)!=""} {
			balloon $widget([lindex $widget(update,undo) 0]) \
				[move::lastUndoComment [lindex $widget(update,undo) 1]]
		}
		if {$widget(update,redo)!=""} {
			balloon $widget([lindex $widget(update,redo) 0]) \
				[move::nextRedoComment [lindex $widget(update,redo) 1]]
		}
	
		menuSetState

	} elseif {$domain=="s_call"} {
		balloon $widget(s_undo) [move::lastUndoComment "" s_call]
		balloon $widget(s_redo) [move::nextRedoComment "" s_call]

		if {[move::isUndo 1 "s_call"]} {
			$widget(s_undo) configure -state normal
			$widget(s_undo_all) configure -state normal
		} else {
			$widget(s_undo) configure -state disabled
			$widget(s_undo_all) configure -state disabled
		}
		if {[move::isRedo 1 "s_call"]} {
			$widget(s_redo) configure -state normal
			$widget(s_redo_all) configure -state normal
		} else {
			$widget(s_redo) configure -state disabled
			$widget(s_redo_all) configure -state disabled
		}
	}
}

proc renameObj {id} {
}

proc playPrompt {which} {
	global curobj statusMsg tcl_platform widget

	if {[info exists widget($which)]} {
		set tmp [string trim [$widget($which) get 0.0 end]]
	} else {
		set tmp [string trim [$which get 0.0 end]]
	}
	set wav [play::prompt $tmp]
	if {$wav!=""} {
		$wav play
		#debug "[$wav length -unit SECONDS] sec"
		set destroyAfter [expr 2+round(1000*[$wav length -unit SECONDS])]
		after $destroyAfter "$wav destroy"
	}

	if {[info exists curobj($which)]} {
		set pic [play::picture $curobj($which)]
	}
	#if {$pic!=""} {
	#	after 60000 "catch \"destroy $pic\""
	#}
}

proc showLog {} {
	showFile [ini::Str files.logFile]
}

proc showFile {fn} {
	global statusMsg tcl_platform

	# execute the play-command
	set cmd [ini::Str $tcl_platform(platform).show $fn]
	catch {exec cmd /c $cmd &} statusMsg
}
