#==========================================================================================
#
# 	Written by Richard Breuer (richard.breuer@gmx.de)
#
#	resource file handling (multiple languages)
#
#==========================================================================================
# Jan 02, 2000	Namespace [RB]
# Dec 06, 1999	First Version [RB]
#==========================================================================================

namespace eval res {

set RES() ""

proc Read {fn} {
  # read a resource file and store its contents in RES
  variable RES

  catch {
    set f [open $fn r]
		fconfigure $f -encoding utf-8
    array set RES [read $f]
    close $f
  }

  #puts "[array get RES]"
}

proc Str {strix args} {
  variable RES

  if {[info exists RES($strix)]} {
    if {$args=={}} {
      return $RES($strix)
    } else {
      return [eval format \"$RES($strix)\" $args]
    }
  } else {
    return "Unkown res '$strix' ('$args')"
  }
}

proc Exists {strix} {
  variable RES

  if {[info exists RES($strix)]} {
		return 1
  } else {
		return 0
  }
}

}